[![gitlab-ico]][gitlab-link]
[![licence-apache20]](/LICENCE.txt)
[![pipeline-status]][pipeline-report]

Python Type Stubs
=================

*A collection of Python stub packages for third party packages.*

This distribution installs stub packages for a number of third party packages that currently 
are not included with [typeshed][].  The quality is possibly not great and hopefully, in the 
near future, either the packages will add type annotations themselves or stub packages will 
be added to [typeshed][].


Install with Pip
----------------

Although all the stub packages are installed, type checkers which support [PEP-561][] will 
only use them if the package they target is also installed.

The distribution supplies a number of package extras, one for each targeted package.  These 
extras provide both a convenience for installing the desired target packages, and a way to 
control supported versions.

| extra           | target package            |
| --------------- | ------------------------- |
| jsonpath        | jsonpath-python [^1]      |
| parse           | parse                     |

To install both *jsonpath* and *parse* extras, for instance, use the following *pip* 
command:

```sh
pip install git+https://code.kodo.org.uk/dom/type-stubs.git#type-stubs[jsonpath,parse]
```

---

[^1]: There *is* a distribution called *jsonpath*, however it is pre-release and appears to 
  be dead. Both distributions install to the same package name.

[typeshed]:
  https://github.com/python/typeshed
  "Typeshed python package on GitHub"

[PEP-561]:
  https://www.python.org/dev/peps/pep-0561/
  "PEP-561: Distribution and Packaging Type Information"

[gitlab-ico]:
  https://img.shields.io/badge/GitLab-code.kodo.org.uk-blue.svg?logo=gitlab
  "GitLab"

[gitlab-link]:
  https://code.kodo.org.uk/dom/type-stubs
  "Go to the project at code.kodo.org.uk"

[licence-apache20]:
  https://img.shields.io/badge/License-Apache--2.0-blue.svg
  "Licence: Apache License 2.0"

[pipeline-status]:
  https://code.kodo.org.uk/dom/type-stubs/badges/master/pipeline.svg

[pipeline-report]:
  https://code.kodo.org.uk/dom/type-stubs/pipelines?ref=master
  "Pipelines"
