from collections import defaultdict
from typing import Any
from typing import Literal
from typing import overload

__version__: str
__author__: str


class ExprSyntaxError(Exception): ...


class JSONPath:

	segments: tuple[str, ...]
	lpath: int
	subx: defaultdict[str, list[str]]
	result: list[Any]
	result_type: Literal["VALUE"] | Literal["PATH"]

	def __init__(self, expr: str): ...

	@overload
	def parse(self, obj: Any, result_type: Literal["VALUE"] = "VALUE") -> list[Any]: ...

	@overload
	def parse(self, obj: Any, result_type: Literal["PATH"]) -> list[str]: ...
